def tri_crepe_recursif(pile):
    """
    Fonction qui reçoit en argument une liste d'entiers non 
    triés, et qui retourne la liste triée par ordre croissant 
    par fonction récursive.
    """
    if len(pile) == 1:
        return pile
    indice_gc = indice_grande_crepe(pile, len(pile)-1)
    pile = rotation_liste(pile, indice_gc)
    pile = rotation_liste(pile, len(pile)-1)
    return tri_crepe_recursif(pile[:len(pile) - 1]) + [pile[-1]] 


def indice_grande_crepe(pile, index):
    """
    Fonction qui reçoit en argument une liste d'entiers non 
    triés et un entier index qui correspond à l'indice du 
    dernier élément de la liste non triée.
    La fonction retourne l'indice de la plus grande crêpe 
    de la liste.
    """
    indice_gc = 0
    for i in range(index + 1):
        if pile[i] > pile[indice_gc]:
            indice_gc = i
    return indice_gc


def rotation_liste(pile, index):
    """
    Glisser la spatule sous la crêpe au bon index et retourner 
    le tableau selectionné pour mettre la grande crêpe en haut
    """
    nombre_inversions = (index + 1) // 2
    for i in range(nombre_inversions):
        j = index - i
        pile[i], pile[j] = pile[j], pile[i] 
    return pile



if __name__ == '__main__':
    #les nombres correspondent à la taille des crêpes
    pile = [1, 4, 5, 2, 12, 8, 6, 7, 9, 3] 
    print("\ncrêpes non trièes:")
    print (pile)
    print( "\nLes itérations:")
    pile = tri_crepe_recursif(pile)
    print( "\nCrêpes triées:", pile)
