import time
from random import sample
import matplotlib.pyplot as plt



def indice_grande_crepe(pile, index): # Mystere A
    """
    Fonction qui reçoit en argument une liste d'entiers non triées et un entier index qui
    corespond à l'indice du dernier élément de la liste non triée.
    La fonction retourne l'indice de la plus grande crêpe de la liste.
    """
    indice_gc = 0
    for i in range(index + 1):
        if pile[i] > pile[indice_gc]:
            indice_gc = i
    return indice_gc


def rotation_liste(pile, index): # Mystère B
    """
    glisser la spatule sous la crêpe au bon index et retourner le pileleau electionné
    pour mettre la grande crêpe en haut
    """
    pile_modifie = pile[:(index + 1)] #selection de la partie de la pile selectionnée
    pile_modifie.reverse() #inversion des valeur du pileleau selectionné
    pile_modifie += pile[(index + 1):] #recomposition de la pilele
    return pile_modifie


def ordonner(pile):
    # Debut du decompte du temps
    start_time = time.time()

    for i in (range(len(pile)-1, -1, -1)): #i nombre de crêpes de la pile restant à trier
        # calcul de l'indice max de la plus grand crêpe
        indice_max = indice_grande_crepe(pile, i)
        # on retourne la pile de crêpes à partir de la plus grande
        pile = rotation_liste(pile, indice_max)
        #print("\nMonter la grande crêpe", pile)
        # on retourne uniquement la pile de crêpes non triées
        pile = rotation_liste(pile, i)
        #print("Retourner la pile de crêpes", pile)
    #return(pile)
    """
    Affichage du temps d execution
    """
    temps = time.time() - start_time
    print("\n---Temps d execution : %s secondes ---" % round(temps,2))
    #return(pile)
    return(temps)

"""
pile = sample(range(1,100), 10)
print("\ncrêpes non trièes:")
print (pile)
#print( "\nLes itérations:")
ordonner(pile)
"""

"""
test d'exécution
"""
def test(n):
    taille_pile = []
    for i in range(1, n + 1):
        taille_pile.append(500*i)
    temps_pile = []
    for taille in taille_pile:
        pile = sample(range(1, 100000), taille)
        temps_pile.append(ordonner(pile))
    #return(taille_pile,temps_pile)
    graphique(taille_pile, temps_pile)

# représentation graphique
def graphique(x, y):
    plt.title("Coût en fonction de la taille de la pile")
    plt.ylabel("Temps d\'exécution du tri")
    plt.xlabel("Nombre de crèpes")
    plt.plot(x, y)
    plt.show()

if __name__ == '__main__':
    test(20)