import time
from random import sample
import matplotlib.pyplot as plt
import numpy as np
import matplotlib.animation as animation




def indice_grande_crepe(pile, index): # Mystere A
    """
    Fonction qui reçoit en argument une liste d'entiers non triées et un entier index qui
    corespond à l'indice du dernier élément de la liste non triée.
    La fonction retourne l'indice de la plus grande crêpe de la liste.
    """
    indice_gc = 0
    for i in range(index + 1):
        if pile[i] > pile[indice_gc]:
            indice_gc = i
    return indice_gc


def rotation_liste(pile, index): # Mystère B
    """
    glisser la spatule sous la crêpe au bon index et retourner le pileleau electionné
    pour mettre la grande crêpe en haut
    """
    pile_modifie = pile[:(index + 1)] #selection de la partie de la pile selectionnée
    pile_modifie.reverse() #inversion des valeur du pileleau selectionné
    pile_modifie += pile[(index + 1):] #recomposition de la pilele
    return pile_modifie


def ordonner(pile, data):
    for i in (range(len(pile)-1, -1, -1)): #i nombre de crêpes de la pile restant à trier
        # calcul de l'indice max de la plus grand crêpe
        indice_max = indice_grande_crepe(pile, i)
        # on retourne la pile de crêpes à partir de la plus grande
        pile = rotation_liste(pile, indice_max)
        #print("\nMonter la grande crêpe", pile)
        data.append(pile)
        # on retourne uniquement la pile de crêpes non triées
        pile = rotation_liste(pile, i)
        #print("Retourner la pile de crêpes", pile)
        data.append(pile)
    #print( "\nCrêpes triées:",pile)
    return(data)


""" Animation n crèpes """
def dessine_crepes():
    n = 50
    x=np.arange(n)
    #data=[[17, 14, 3, 96, 27, 24, 8, 95, 62, 50],[96, 3, 14, 17, 27, 24, 8, 95, 62, 50],[50, 62, 95, 8, 24, 27, 17, 14, 3, 96],[95, 62, 50, 8, 24, 27, 17, 14, 3, 96],[3, 14, 17, 27, 24, 8, 50, 62, 95, 96],[50, 8, 24, 27, 17, 14, 3, 62, 95, 96],[62, 3, 14, 17, 27, 24, 8, 50, 95, 96],[62, 3, 14, 17, 27, 24, 8, 50, 95, 96],[8, 24, 27, 17, 14, 3, 62, 50, 95, 96],[27, 24, 8, 17, 14, 3, 62, 50, 95, 96],[3, 14, 17, 8, 24, 27, 62, 50, 95, 96],[17, 14, 3, 8, 24, 27, 62, 50, 95, 96],[24, 8, 3, 14, 17, 27, 62, 50, 95, 96],[24, 8, 3, 14, 17, 27, 62, 50, 95, 96],[14, 3, 8, 24, 17, 27, 62, 50, 95, 96],[14, 3, 8, 24, 17, 27, 62, 50, 95, 96],[8, 3, 14, 24, 17, 27, 62, 50, 95, 96],[8, 3, 14, 24, 17, 27, 62, 50, 95, 96],[3, 8, 14, 24, 17, 27, 62, 50, 95, 96],[3, 8, 14, 24, 17, 27, 62, 50, 95, 96],[3, 8, 14, 24, 17, 27, 62, 50, 95, 96]]

    fig = plt.figure()
    pile1 = plt.bar(x, data[0], align='center')   # Diagramme en barres
    plt.xlabel('Crêpes')
    plt.ylabel('Taille')
    plt.ylim(0, 100)

    def animate(i):
        for crepe, taille in zip(pile1, data[i]):
            crepe.set_height(taille)
    ani = animation.FuncAnimation(fig, animate , frames=len(data), interval=500, repeat=False)
    plt.show()



if __name__ == '__main__':
    data=[]
    pile = sample(range(1, 100), 50)
    #print("\ncrêpes non trièes:")
    data.append(pile)
    #print( "\nLes itérations:")
    ordonner(pile, data)
    dessine_crepes()