import matplotlib.pyplot as plt
from random import sample

def indice_grande_crepe(pile, index): # Mystere A
    """
    Fonction qui reçoit en argument une liste d'entiers non triées et un entier index qui
    corespond à l'indice du dernier élément de la liste non triée.
    La fonction retourne l'indice de la plus grande crêpe de la liste.
    """
    compteur1 = 0
    indice_gc = 0
    for i in range(index+1):
        if pile[i] > pile[indice_gc]:
            indice_gc = i
            compteur1 += 2
    return (indice_gc,compteur1)


def rotation_liste(pile, index): # Mystère B
    """
    Fonction qui glisse la spatule sous la crêpe au bon index et retourne la pile du haut sélectionné
    pour mettre la grande crêpe en haut
    """
    pile_modifie = pile[:(index + 1)] #selection de la partie de la pile selectionnée
    #### reverse() non comptée comme une opération élémentaire. Que cache-t-elle?
    pile_modifie.reverse() #inversion des valeur du pileleau selectionné
    pile_modifie += pile[(index + 1):] #recomposition de la pilele
    compteur2 = 2
    return (pile_modifie,compteur2)


def ordonner(pile):
    #On initialise de compteur d'opérations élémentaires
    compteur = 0
    for i in (range(len(pile)-1, -1, -1)):#i nombre de crêpes de la pile restant à trier
        # calcul de l'indice max de la plus grand crêpe
        indice_max,compteur1 = indice_grande_crepe(pile, i)
        compteur += compteur1
        # on retourne la pile de crêpes à partir de la plus grande
        pile,compteur2 = rotation_liste(pile, indice_max)
        compteur += compteur2
        #print("\nMonter la grande crêpe", pile)
        # on retourne uniquement la pile de crêpes non triées
        pile,compteur2 = rotation_liste(pile, i)
        compteur += compteur2
        #print("Retourner la pile de crêpes", pile)
    return(pile,compteur)


"""
test d'exécution
"""
def test(n):
    taille_pile=[]
    for i in range(1,n+1):
        taille_pile.append(500*i)
    operations_pile=[]
    for taille in taille_pile:
        pile = sample(range(1,100000), taille)
        pile_triee, nb_operations = ordonner(pile)
        operations_pile.append(nb_operations)
    #return(taille_pile,temps_pile)
    graphique(taille_pile,operations_pile)

# représentation graphique
def graphique(x,y):
    plt.title("Coût en fonction de la taille de la pile")
    plt.ylabel("Nombre d'opérations sur la pile")
    plt.xlabel("Nombre de crèpes")
    plt.plot(x,y)
    plt.show()

if __name__ == '__main__':
    test(50)